"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Failure = exports.Success = void 0;
/**
 * A successful result.
 * Use [[value]] or call [[unwrap]] to retreive the value.
 */
var Success = /** @class */ (function () {
    function Success(value) {
        this.value = value;
        this.isSuccess = true;
        this.isFailure = false;
        this.failure = undefined;
    }
    Success.prototype.unwrap = function () {
        return this.value;
    };
    return Success;
}());
exports.Success = Success;
/**
 * A failure result.
 * Use [[failure]] to retrieve the failure value.
 * Call [[unwrap]] to throw as an Error.
 */
var Failure = /** @class */ (function () {
    function Failure(failure, unwrapper) {
        this.failure = failure;
        this.unwrapper = unwrapper;
        this.isSuccess = false;
        this.isFailure = true;
    }
    Failure.prototype.unwrap = function () {
        return this.unwrapper(this.failure);
    };
    return Failure;
}());
exports.Failure = Failure;
//# sourceMappingURL=result.js.map